# Dart Code Coverage Generator
[![Build Status](https://travis-ci.org/codecov/dart.svg?branch=master)](https://travis-ci.org/codecov/dart) [![codecov.io](http://codecov.io/github/codecov/dart/coverage.svg?branch=master)](http://codecov.io/github/codecov/dart?branch=master)
[![FOSSA Status](https://app.fossa.com/api/projects/git%2Bgithub.com%2Fcodecov%2Fdart.svg?type=shield)](https://app.fossa.com/projects/git%2Bgithub.com%2Fcodecov%2Fdart?ref=badge_shield)

> Generate code coverage for Dart projects. Output can be [lcov](http://ltp.sourceforge.net/coverage/lcov.php) format or an HTML report.

This project includes a `codecov` executable that runs one or many test files and uses the `coverage` package to collect coverage for each file and format the coverage into the desired output format.


## Prerequisites
Depends on the following utilities:

- genhtml (`brew install lcov` on a mac)
- lsof (standard unix utility)


## Installation

Add this to your package's pubspec.yaml file:
```yaml
dependencies:
  coverage: "^0.7.0"
  codecov: "^0.4.0"
```

Install:
```
pub get --packages-dir
```


## Usage
```
pub run codecov
```


## Configuration
By default, this tool runs every test file in the `test/` directory. You can explicitly specify the directories or files like so:
```
pub run codecov test/my_test.dart
```

### Options
- `--report-on`: Which directories or files to report coverage on. For example, `--report-on=lib/`.

### Flags
- `--html`: Whether or not to generate the HTML report. Defaults to true.
- `--lcov`: Whether or not to generate the .lcov file. Defaults to true.
- `--verbose`: Toggle verbose output to stdout.

## Notice

The tooling currently relies on the deprecated packages directories generated by pub. If the `.packages` file should be used instead, modify the call to `pub run coverage:format_coverage` in `bin/src/coverage.dart`, replacing `--package-root=packages` with `--packages=.packages`.


## License
[![FOSSA Status](https://app.fossa.com/api/projects/git%2Bgithub.com%2Fcodecov%2Fdart.svg?type=large)](https://app.fossa.com/projects/git%2Bgithub.com%2Fcodecov%2Fdart?ref=badge_large)
